(* File lexer.mll *)
{
  open Syntax;;        (* The type token is defined in parser.mli *)
  exception Eof;;
}
rule token = parse
[' ' '\t']       { token lexbuf }     (* skip blanks *)
| '\n'           { EOL }
| 'v'            { SOMMEA }
| '^'            { PRODA }
| '*'            { PRODM }
| "->"           { IMPLA }
| "-*"           { IMPLM }
| '('            { LPAREN }
| ')'            { RPAREN }
| "depth"        { DEPTH }
| "check"        { CHECK }
| "strategy"     { STRATEGY }
| "slow"         { SLOW }
| "fast"         { FAST }
| "help"         { HELP }
| "stat"         { STAT }
| "tex"          { TEXCM }
| "cm"[' '-'z']* { FILE(Lexing.lexeme lexbuf)}
| ['0'-'9']+     { INT(int_of_string (Lexing.lexeme lexbuf))}
| 'T'            { TOP }
| ['A'-'S''U'-'Z''a'-'u''w'-'z']{ INT(Char.code ((Lexing.lexeme lexbuf).[0]))}
| eof            { raise Eof }
| _              { ERROR }

