/* File parser.mly */
%{
  open Prover.Types;;
%}
%token <int> INT
%token <string> FILE
%token SOMMEA PRODA PRODM IMPLA IMPLM TOP ONE BOT
%token CHECK HELP DEPTH STAT TEXCM STRATEGY SLOW FAST
%token LPAREN RPAREN 
%token EOL ERROR

%left IMPLA IMPLM
%left SOMMEA
%left PRODA PRODM 


%start main             /* the entry point */
%type <Prover.Types.injonction> main
%%
main: 
injonction EOL           { $1 }
;

injonction:       { No_operation } 
| CHECK expr      { Check $2 }
| DEPTH INT       { Search_depth $2 }
| HELP            { Help }
| STAT            { Stat }
| TEXCM FILE      { TeXcm $2 }
| STRATEGY SLOW   { Strategy false }
| STRATEGY FAST   { Strategy true }
| error           { Syntax_error }
;

expr:
  INT                     { V $1 }
| TOP                     { ImplA (V (Char.code 'T'), V (Char.code 'T')) }
| LPAREN expr RPAREN      { $2 }
| expr SOMMEA expr        { SommeA ($1, $3) }
| expr PRODA expr         { ProdA ($1, $3) }
| expr PRODM expr         { ProdM ($1, $3) }
| expr IMPLA expr         { ImplA ($1, $3) }
| expr IMPLM expr         { ImplM ($1, $3) }
;






