(* File lexer.mll *)
{
  open Syntax        (* The type token is defined in parser.mli *)
  exception Eof
}
rule token = parse
[' ' '\t']       { token lexbuf }     (* skip blanks *)
| '\n'           { EOL }
| '*'            { PRODM }
| "-*"           { IMPLM }
| '('            { LPAREN }
| ')'            { RPAREN }
| "check"        { CHECK }
| "help"         { HELP }
| "stat"         { STAT }
| "strategy"     { STRATEGY }
| "slow"         { SLOW }
| "fast"         { FAST }
| ['a'-'z''A'-'Z']{ INT(Char.code ((Lexing.lexeme lexbuf).[0]))}
| eof            { raise Eof }
| _              { ERROR }
