/* File parser.mly */
%{
  open Prover;;
%}
%token <int> INT
%token PRODM IMPLM  SLOW FAST
%token STRATEGY CHECK HELP STAT
%token LPAREN RPAREN
%token EOL ERROR

%left IMPLM
%left PRODM

%start main             /* the entry point */
%type <Prover.injonction> main
%%
main:
  injonction EOL                 { $1 }
;

injonction:              { No_operation }
| CHECK expr             { Check $2 }
| HELP                   { Help }
| STAT                   { Stat }
| STRATEGY SLOW          { Strategy false }
| STRATEGY FAST          { Strategy true }
| error                  { Syntax_error }
;

expr:
  INT                     { Mill.V $1 }
| LPAREN expr RPAREN      { $2 }
| expr PRODM expr         { Mill.And  ($1, $3) }
| expr IMPLM expr         { Mill.Impl ($1, $3) }
;
